unit NullableTypes;

{$mode delphi}

interface

uses
  TypInfo,
  NullableTypes.Ordinal;
type
  { Ordinal Numeric Types }

  {NullableByte       = NullableTypes.Ordinal.Nullable<Byte>;
  NullableWord       = NullableTypes.Ordinal.Nullable<Word>;
  NullableCardinal   = NullableTypes.Ordinal.Nullable<Cardinal>;
  NullableLongword   = NullableTypes.Ordinal.Nullable<Longword>;
  NullableQWord      = NullableTypes.Ordinal.Nullable<QWord>;

  NullableShortInt   = NullableTypes.Ordinal.Nullable<ShortInt>;
  NullableSmallInt   = NullableTypes.Ordinal.Nullable<SmallInt>;
  NullableInteger    = NullableTypes.Ordinal.Nullable<Integer>;
  NullableLongInt    = NullableTypes.Ordinal.Nullable<LongInt>;
  NullableInt64      = NullableTypes.Ordinal.Nullable<Int64>;

  NullableNativeInt  = NullableTypes.Ordinal.Nullable<NativeInt>;
  NullableNativeUInt = NullableTypes.Ordinal.Nullable<NativeUInt>;}

  { Boolean Types }

  //NullableBoolean  = NullableTypes.Boolean.Nullable<Boolean>;


  { TNullableUtils }

  TNullableUtils = class(TObject)
  public
    class function IsNullableType(typeInfo: PTypeInfo): Boolean;
  end;

implementation

uses
  SysUtils,
  StrUtils;

{ TNullableUtils }

class function TNullableUtils.IsNullableType(typeInfo: PTypeInfo): Boolean;
const
  PrefixString = 'Nullable';    // DO NOT LOCALIZE
begin
  Result := Assigned(typeInfo)
            and (typeInfo.Kind = tkRecord)
            and AnsiStartsText(PrefixString, typeInfo^.Name);
end;

end.

