unit NullableTypes.String;

{$mode delphi}

interface

uses
  TypInfo,
  NullableTypes.Exception,
  NullableTypes.SupportTypes;

type
  { Nullable<T> }

  Nullable<T> = record
  strict private
     {$INCLUDE nullabletype.base.privatemembers.inc}
  public
     {$INCLUDE nullabletype.base.publicmembers.inc}
     {$INCLUDE nullabletype.comparisionoperators.interface.inc}

     class operator Add(A,B: Nullable<T>): Nullable<T>;
  end;

  { Characters }

  NullableString = Nullable<String>;

implementation

uses
  Variants;

{$INCLUDE nullabletype.base.implementation.inc}
{$INCLUDE nullabletype.comparisionoperators.implementation.inc}

class operator Nullable<T>.Add(A,B: Nullable<T>): Nullable<T>;
begin
  Result := A.Value + A.Value;
end;

end.

