unit NullableTypes.SupportTypes;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

type

{ TNullableMockInterfacedObject }

  TNullableMockInterfacedObject = class(TObject, IUnknown)
  strict private
    class var FInstance: TNullableMockInterfacedObject;
    class function GetInstance: TNullableMockInterfacedObject; static;
    class constructor Create;
    class destructor Destroy;

    function QueryInterface({$IFDEF FPC_HAS_CONSTREF}constref{$ELSE}const{$ENDIF} iid : tguid;out obj) : longint;{$IFNDEF WINDOWS}cdecl{$ELSE}stdcall{$ENDIF};
    function _AddRef : longint;{$IFNDEF WINDOWS}cdecl{$ELSE}stdcall{$ENDIF};
    function _Release : longint;{$IFNDEF WINDOWS}cdecl{$ELSE}stdcall{$ENDIF};
  public
    class property Instance: TNullableMockInterfacedObject read GetInstance;
  end;

implementation

{ TNullableMockInterfacedObject }

class constructor TNullableMockInterfacedObject.Create;
begin
  FInstance := TNullableMockInterfacedObject.Create;
end;

class destructor TNullableMockInterfacedObject.Destroy;
begin
  FInstance.Free;
end;

function TNullableMockInterfacedObject.QueryInterface(
  {$IFDEF FPC_HAS_CONSTREF}constref{$ELSE}const{$ENDIF} iid : tguid;out obj) : longint;{$IFNDEF WINDOWS}cdecl{$ELSE}stdcall{$ENDIF};
begin
  Result := E_NOINTERFACE;
end;

function TNullableMockInterfacedObject._AddRef: longint; {$IFNDEF WINDOWS}cdecl{$ELSE}stdcall{$ENDIF};
begin
  Result := -1;
end;

function TNullableMockInterfacedObject._Release: longint; {$IFNDEF WINDOWS}cdecl{$ELSE}stdcall{$ENDIF};
begin
  Result := -1;
end;

class function TNullableMockInterfacedObject.GetInstance: TNullableMockInterfacedObject;
  static;
begin
  Result := FInstance;
end;

end.

